diff -urN sourceold/scripts/mdb.cpp source/scripts/mdb.cpp
--- sourceold/scripts/mdb.cpp	2018-10-27 22:04:56.512400000 +1000
+++ source/scripts/mdb.cpp	2020-09-10 09:08:27.972483200 +1000
@@ -292,7 +292,7 @@
 	}
 }
 
-void MDB_Unit_Limit::Destroyed(GameObject *obj)
+void MDB_Unit_Limit::Killed(GameObject *obj,GameObject *killer)
 {
 	ReEnable();
 }
diff -urN sourceold/scripts/mdb.h source/scripts/mdb.h
--- sourceold/scripts/mdb.h	2018-10-27 22:04:56.513400000 +1000
+++ source/scripts/mdb.h	2020-09-10 09:08:27.973761100 +1000
@@ -74,7 +74,7 @@
 	PurchaseSettingsDefClass::TEAM Team;
 	unsigned int Definitions[4];
 	void Created(GameObject *obj);
-	void Destroyed(GameObject *obj);
+	void Killed(GameObject *obj,GameObject *killer);
 	public: void Register_Auto_Save_Variables();
 	void ReEnable();
 };
diff -urN sourceold/scripts/mdbdef.cpp source/scripts/mdbdef.cpp
--- sourceold/scripts/mdbdef.cpp	2018-10-27 22:04:56.514400000 +1000
+++ source/scripts/mdbdef.cpp	2020-09-10 09:08:27.973761100 +1000
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Copyright 2013 Tiberian Technologies
+	Copyright 2015 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -112,11 +112,6 @@
 	}
 }
 
-void MDB_Base_Defense_Popup_No_VTOL::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void MDB_Base_Defense_Popup_No_VTOL::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -289,11 +284,6 @@
 	}
 }
 
-void MDB_Base_Defense_Popup_VTOL_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void MDB_Base_Defense_Popup_VTOL_Only::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -429,11 +419,6 @@
 	}
 }
 
-void MDB_Base_Defense_Popup::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	Commands->Action_Reset(obj,100);
-}
-
 void MDB_Base_Defense_Popup::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -485,17 +470,17 @@
 	Commands->Enable_Enemy_Seen(obj,true);
 	Vector3 pos = Commands->Get_Position(obj);
 	V[0].X = pos.X - 10;
-	V[0].Y = pos.Y - 10;
+	V[0].Y = pos.Y;
 	V[0].Z = pos.Z + 2;
 	V[1].X = pos.X + 10;
 	V[1].Y = pos.Y;
 	V[1].Z = pos.Z + 2;
-	V[2].X = pos.X + 10;
+	V[2].X = pos.X;
 	V[2].Y = pos.Y - 10;
 	V[2].Z = pos.Z + 2;
 	V[3].X = pos.X;
 	V[3].Y = pos.Y + 10;
-	V[3].Z = pos.Z + 4;
+	V[3].Z = pos.Z + 2;
 	ActionParamsStruct var;
 	var.Set_Basic(this,1,2);
 	var.Set_Attack(V[Commands->Get_Random_Int(0,4)],0.0,0.0,true);
@@ -525,18 +510,10 @@
 		params.AttackCheckBlocked = true;
 	}
 	LastSeen = Commands->Get_ID(enemy);
-	Commands->Start_Timer(obj,this,5.0f,3);
+	Commands->Start_Timer(obj,this,1.0f,2);
 	Commands->Action_Attack(obj,params);
 }
 
-void MDB_Base_Defense::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 1)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void MDB_Base_Defense::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -544,6 +521,7 @@
 		ActionParamsStruct var;
 		var.Set_Basic(this,1,2);
 		var.Set_Attack(V[Commands->Get_Random_Int(0,4)],0.0,0.0,true);
+		Commands->Action_Attack(obj,var);
 		Commands->Start_Timer(obj,this,Commands->Get_Random(5.0f,15.0f),1);
 	}
 	else if (number == 2)
@@ -581,17 +559,17 @@
 	Commands->Enable_Enemy_Seen(obj,true);
 	Vector3 pos = Commands->Get_Position(obj);
 	V[0].X = pos.X - 10;
-	V[0].Y = pos.Y - 10;
+	V[0].Y = pos.Y;
 	V[0].Z = pos.Z + 2;
 	V[1].X = pos.X + 10;
 	V[1].Y = pos.Y;
 	V[1].Z = pos.Z + 2;
-	V[2].X = pos.X + 10;
+	V[2].X = pos.X;
 	V[2].Y = pos.Y - 10;
 	V[2].Z = pos.Z + 2;
 	V[3].X = pos.X;
 	V[3].Y = pos.Y + 10;
-	V[3].Z = pos.Z + 4;
+	V[3].Z = pos.Z + 2;
 	ActionParamsStruct var;
 	var.Set_Basic(this,1,2);
 	var.Set_Attack(V[Commands->Get_Random_Int(0,4)],0.0,0.0,true);
@@ -623,19 +601,11 @@
 			params.AttackCheckBlocked = true;
 		}
 		LastSeen = Commands->Get_ID(enemy);
-		Commands->Start_Timer(obj,this,5.0f,3);
+		Commands->Start_Timer(obj,this,1.0f,2);
 		Commands->Action_Attack(obj,params);
 	}
 }
 
-void MDB_Base_Defense_No_VTOL::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 1)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void MDB_Base_Defense_No_VTOL::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -643,6 +613,7 @@
 		ActionParamsStruct var;
 		var.Set_Basic(this,1,2);
 		var.Set_Attack(V[Commands->Get_Random_Int(0,4)],0.0,0.0,true);
+		Commands->Action_Attack(obj,var);
 		Commands->Start_Timer(obj,this,Commands->Get_Random(5.0f,15.0f),1);
 	}
 	else if (number == 2)
@@ -680,17 +651,17 @@
 	Commands->Enable_Enemy_Seen(obj,true);
 	Vector3 pos = Commands->Get_Position(obj);
 	V[0].X = pos.X - 10;
-	V[0].Y = pos.Y - 10;
-	V[0].Z = pos.Z + 2;
+	V[0].Y = pos.Y;
+	V[0].Z = pos.Z + 5;
 	V[1].X = pos.X + 10;
 	V[1].Y = pos.Y;
-	V[1].Z = pos.Z + 2;
-	V[2].X = pos.X + 10;
+	V[1].Z = pos.Z + 5;
+	V[2].X = pos.X;
 	V[2].Y = pos.Y - 10;
-	V[2].Z = pos.Z + 2;
+	V[2].Z = pos.Z + 5;
 	V[3].X = pos.X;
 	V[3].Y = pos.Y + 10;
-	V[3].Z = pos.Z + 4;
+	V[3].Z = pos.Z + 5;
 	ActionParamsStruct var;
 	var.Set_Basic(this,1,2);
 	var.Set_Attack(V[Commands->Get_Random_Int(0,4)],0.0,0.0,true);
@@ -717,14 +688,6 @@
 	}
 }
 
-void MDB_Base_Defense_VTOL_Only::Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason)
-{
-	if (action_id == 1)
-	{
-		Commands->Action_Reset(obj,100);
-	}
-}
-
 void MDB_Base_Defense_VTOL_Only::Timer_Expired(GameObject *obj,int number)
 {
 	if (number == 1)
@@ -732,6 +695,7 @@
 		ActionParamsStruct var;
 		var.Set_Basic(this,1,2);
 		var.Set_Attack(V[Commands->Get_Random_Int(0,4)],0.0,0.0,true);
+		Commands->Action_Attack(obj,var);
 		Commands->Start_Timer(obj,this,Commands->Get_Random(5.0f,15.0f),1);
 	}
 	else if (number == 2)
diff -urN sourceold/scripts/mdbdef.h source/scripts/mdbdef.h
--- sourceold/scripts/mdbdef.h	2018-10-27 22:04:56.515400000 +1000
+++ source/scripts/mdbdef.h	2020-09-10 09:08:27.974759900 +1000
@@ -1,5 +1,5 @@
 /*	Renegade Scripts.dll
-	Copyright 2013 Tiberian Technologies
+	Copyright 2015 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
 	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
@@ -20,7 +20,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int type, int param, GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	void Animation_Complete(GameObject *obj,const char *animation_name);
 	public: void Register_Auto_Save_Variables();
@@ -37,7 +36,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int type, int param, GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	void Animation_Complete(GameObject *obj,const char *animation_name);
 	public: void Register_Auto_Save_Variables();
@@ -51,7 +49,6 @@
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj, int type, int param, GameObject *sender);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	void Animation_Complete(GameObject *obj,const char *animation_name);
 	public: void Register_Auto_Save_Variables();
@@ -64,7 +61,6 @@
 	int LastSeen;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -76,7 +72,6 @@
 	int LastSeen;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
@@ -87,7 +82,6 @@
 	float MaxDis;
 	void Created(GameObject *obj);
 	void Enemy_Seen(GameObject *obj,GameObject *enemy);
-	void Action_Complete(GameObject *obj,int action_id,ActionCompleteReason complete_reason);
 	void Timer_Expired(GameObject *obj,int number);
 	public: void Register_Auto_Save_Variables();
 };
